#!/usr/bin/env python

'''
TEL-3214 Computer Communication Networks daemon (ccnd)
Diarmuid O'Briain
'''

# Import libraries

import netifaces
import socket
import sys

# Initialise data structures

addr_list = dict()
BUFFER_SIZE = 20  # Normally 1024, but we want fast response
tcp_port = '5010'
ip_addr = None

# Gather arguments

try: 
    tcp_port = sys.argv[1]
except:
    tcp_port = '5010'
     
# Banner

print '''
Welcome to the TEL-3214 Computer Communication Networks daemon (ccnd)
This program is designed to give students an understanding of the 
client/server architecture through a simple TCP Socket.
'''

# Test the Port number validity

tcp_port = tcp_port.strip()

try: 
    tcp_port = int(tcp_port)
except:
    print "\nPort number is not valid use the following format"
    print sys.argv[0], "[<port 5001-9999 | 5010>]"
    sys.exit()

if tcp_port < 5001 or tcp_port > 9999:
    print "\nPort number is not valid use the following format"
    print sys.argv[0], "[<port 5001-9999 | 5010>]"
    sys.exit()    

print "Starting TCP Server on", tcp_port, "\n"

# Create TCP Server

s = None
for sai in socket.getaddrinfo(ip_addr, tcp_port, socket.AF_UNSPEC, socket.SOCK_STREAM, 0, socket.AI_PASSIVE):
    addr_family, sock_type, proto, canonical_name, sock_addr = sai
    try:
        s = socket.socket(addr_family, sock_type, proto)
    except socket.error as msg:
        s = None
        continue
    try:
        s.bind(sock_addr)
        s.listen(1)
    except socket.error as msg:
        s.close()
        s = None
        continue
    break
if s is None:
    print 'could not open socket'
    sys.exit(1)
conn, addr = s.accept()
print 'Connected by', addr
while 1:
    data = conn.recv(1024)
    if not data: break
    print "Sending received data back to ccnc at", addr[0], "\n"
    conn.send(data)
conn.close()

